
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 7 "grammar.y"


/* C declarations */

/* the mode: the lexer should behave in various ways, depending
 * on this variable
 * possible values:
 * LEXER_NORMAL		parse a word or a symbol, one at a time
 * LEXER_C_CODE		parse some code between '{' and '}'
 * LEXER_F_ARGS		parse a function arguments' list (something like
                        "int x, char* y") or a function call's parameters
			(like "x, y, "a", 'b', 2")
 * LEXER_C_STRING	parse a C string (the ending '"' won't be eaten)
 * LEXER_INCLUDE_STUFF	parse between #include and End Of Line
 * LEXER_INIT_VARS	parse a C block, but omit the '{' and '}'
 *			(the C block shall contain only variables'
 *			declarations)
 * LEXER_C_CODE_NO_BRACKET same meaning as LEXER_INIT_VARS
 */
#define LEXER_NORMAL			0
#define LEXER_C_CODE			1
#define LEXER_F_ARGS			2
#define LEXER_C_STRING			3
#define LEXER_INCLUDE_STUFF		4
#define LEXER_INIT_VARS			5
#define LEXER_C_CODE_NO_BRACKET		6

#include <string.h>

#include "widget.h"
#include "string.h"
#include "identifier.h"
#include "list.h"
#include "c_fun_args.h"
#include "files.h"
#include "keywords.h"

static int lexer_mode = LEXER_NORMAL;
static int line = 0;
static int init_first_shot;

void yyerror(char *);
static char *buffer;
static int buffer_size;
static int buffer_maxsize;
static int put(int);
void end_parse(void);
static int yylex(void);

static keyword buffer_keyword;

widget current_widget;

extern list cinclude;
extern list hinclude;
extern list ccode;
extern list hcode;



/* Line 189 of yacc.c  */
#line 134 "y.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     WIDGET = 258,
     IDENTIFIER = 259,
     FLOAT = 260,
     INTEGER = 261,
     C_STRING = 262,
     C_CODE = 263,
     F_ARGS = 264,
     INCLUDE_STUFF = 265,
     POST_INIT = 266,
     INIT = 267,
     INCLUDE = 268,
     CINCLUDE = 269,
     HINCLUDE = 270,
     INIT_VARS = 271,
     CCODE = 272,
     HCODE = 273,
     KEYWORD = 274
   };
#endif
/* Tokens.  */
#define WIDGET 258
#define IDENTIFIER 259
#define FLOAT 260
#define INTEGER 261
#define C_STRING 262
#define C_CODE 263
#define F_ARGS 264
#define INCLUDE_STUFF 265
#define POST_INIT 266
#define INIT 267
#define INCLUDE 268
#define CINCLUDE 269
#define HINCLUDE 270
#define INIT_VARS 271
#define CCODE 272
#define HCODE 273
#define KEYWORD 274




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 74 "grammar.y"

  widget widget;
  int integer;
  property_value property_value;
  widget_argument_value widget_argument_value;
  float f;



/* Line 214 of yacc.c  */
#line 218 "y.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 230 "y.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   123

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  35
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  56
/* YYNRULES -- Number of rules.  */
#define YYNRULES  90
/* YYNRULES -- Number of states.  */
#define YYNSTATES  147

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   274

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    34,    20,     2,     2,     2,     2,
      23,    24,     2,    31,    33,     2,    26,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    32,    25,
       2,    27,    30,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    28,     2,    29,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    21,     2,    22,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint8 yyprhs[] =
{
       0,     0,     3,     6,     7,    11,    14,    17,    20,    21,
      24,    27,    28,    29,    36,    37,    38,    45,    50,    53,
      56,    58,    60,    65,    66,    69,    74,    75,    76,    77,
      83,    84,    87,    88,    91,    92,    95,    97,    99,   101,
     105,   112,   119,   129,   135,   140,   141,   145,   149,   155,
     157,   161,   163,   165,   167,   169,   171,   173,   175,   179,
     181,   183,   185,   187,   189,   191,   193,   195,   197,   199,
     201,   203,   205,   207,   209,   211,   213,   215,   216,   217,
     223,   228,   230,   231,   234,   235,   236,   242,   243,   246,
     248
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      36,     0,    -1,    37,    39,    -1,    -1,    37,    20,    38,
      -1,    13,    87,    -1,    14,    87,    -1,    15,    87,    -1,
      -1,    39,    45,    -1,    39,    40,    -1,    -1,    -1,    17,
      21,    41,     8,    42,    22,    -1,    -1,    -1,    18,    21,
      43,     8,    44,    22,    -1,    46,    21,    51,    22,    -1,
       3,    47,    -1,     3,    48,    -1,    89,    -1,    90,    -1,
      89,    23,    49,    24,    -1,    -1,    50,     9,    -1,    52,
      55,    57,    56,    -1,    -1,    -1,    -1,    21,    53,    16,
      54,    22,    -1,    -1,    12,    84,    -1,    -1,    11,    84,
      -1,    -1,    57,    58,    -1,    59,    -1,    60,    -1,    61,
      -1,    66,    67,    25,    -1,    66,    67,    23,    68,    24,
      25,    -1,    67,    26,    70,    27,    71,    25,    -1,    67,
      28,    75,    29,    26,    70,    27,    71,    25,    -1,    67,
      30,    62,    64,    25,    -1,    67,    31,    64,    25,    -1,
      -1,    23,    63,    24,    -1,    90,    32,    71,    -1,    63,
      33,    90,    32,    71,    -1,    65,    -1,    64,    33,    65,
      -1,    89,    -1,    90,    -1,    75,    -1,    90,    -1,    89,
      -1,    90,    -1,    69,    -1,    68,    33,    69,    -1,    72,
      -1,    73,    -1,    74,    -1,    77,    -1,    90,    -1,    89,
      -1,    72,    -1,    73,    -1,    74,    -1,    77,    -1,    80,
      -1,    84,    -1,    90,    -1,    89,    -1,    75,    -1,    76,
      -1,     6,    -1,     5,    -1,    -1,    -1,    34,    78,     7,
      79,    34,    -1,    81,    23,    82,    24,    -1,     4,    -1,
      -1,    83,     9,    -1,    -1,    -1,    21,    85,     8,    86,
      22,    -1,    -1,    88,    10,    -1,     4,    -1,    19,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   112,   112,   117,   118,   122,   127,   131,   139,   140,
     142,   148,   150,   147,   158,   160,   157,   170,   175,   179,
     186,   191,   200,   208,   208,   219,   225,   227,   229,   226,
     237,   238,   247,   248,   256,   257,   262,   264,   266,   271,
     282,   296,   306,   330,   361,   395,   398,   405,   418,   432,
     439,   447,   457,   467,   478,   483,   485,   494,   506,   519,
     524,   529,   534,   542,   544,   553,   558,   563,   568,   573,
     579,   587,   592,   597,   601,   608,   620,   633,   635,   632,
     644,   664,   672,   672,   683,   685,   682,   694,   694,   703,
     710
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "WIDGET", "IDENTIFIER", "FLOAT",
  "INTEGER", "C_STRING", "C_CODE", "F_ARGS", "INCLUDE_STUFF", "POST_INIT",
  "INIT", "INCLUDE", "CINCLUDE", "HINCLUDE", "INIT_VARS", "CCODE", "HCODE",
  "KEYWORD", "'#'", "'{'", "'}'", "'('", "')'", "';'", "'.'", "'='", "'['",
  "']'", "'>'", "'+'", "':'", "','", "'\"'", "$accept", "file", "includes",
  "include", "widget_list", "code", "$@1", "$@2", "$@3", "$@4", "widget",
  "widget_declaration", "widget_declaration_simple",
  "widget_declaration_complex", "widget_declaration_arguments", "$@5",
  "widget_body", "init_vars", "$@6", "$@7", "init_code", "post_init_code",
  "widget_body_next", "widget_unit_declaration",
  "widget_element_declaration", "widget_property_setting",
  "widget_packing", "widget_packing_attributes",
  "widget_packing_attributes_list", "widget_pack_name_list",
  "widget_pack_name", "widget_type", "widget_name", "widget_arguments",
  "widget_argument", "property_name", "property_value", "keyword_value",
  "identifier_value", "float_or_integer_value", "integer_value",
  "float_value", "string_value", "$@8", "$@9", "function_call_value",
  "function_name", "function_arguments", "$@10", "c_code_value", "$@11",
  "$@12", "include_string", "$@13", "identifier", "keyword", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
      35,   123,   125,    40,    41,    59,    46,    61,    91,    93,
      62,    43,    58,    44,    34
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    35,    36,    37,    37,    38,    38,    38,    39,    39,
      39,    41,    42,    40,    43,    44,    40,    45,    46,    46,
      47,    47,    48,    50,    49,    51,    52,    53,    54,    52,
      55,    55,    56,    56,    57,    57,    58,    58,    58,    59,
      59,    60,    60,    61,    61,    62,    62,    63,    63,    64,
      64,    65,    65,    65,    66,    67,    67,    68,    68,    69,
      69,    69,    69,    70,    70,    71,    71,    71,    71,    71,
      71,    72,    73,    74,    74,    75,    76,    78,    79,    77,
      80,    81,    83,    82,    85,    86,    84,    88,    87,    89,
      90
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     0,     3,     2,     2,     2,     0,     2,
       2,     0,     0,     6,     0,     0,     6,     4,     2,     2,
       1,     1,     4,     0,     2,     4,     0,     0,     0,     5,
       0,     2,     0,     2,     0,     2,     1,     1,     1,     3,
       6,     6,     9,     5,     4,     0,     3,     3,     5,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     0,     5,
       4,     1,     0,     2,     0,     0,     5,     0,     2,     1,
       1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       3,     0,     8,     1,     0,     2,    87,    87,    87,     4,
       0,     0,     0,    10,     9,     0,     5,     0,     6,     7,
      89,    90,    18,    19,    20,    21,    11,    14,    26,    88,
      23,     0,     0,    27,     0,    30,     0,     0,    12,    15,
       0,    17,     0,    34,    22,    24,     0,     0,    28,    84,
      31,    32,    13,    16,     0,     0,     0,    25,    35,    36,
      37,    38,     0,     0,    55,    56,    29,    85,    33,     0,
      56,     0,     0,    45,     0,     0,     0,    39,     0,    64,
      63,    75,     0,     0,     0,     0,    49,    53,    51,    52,
      86,    76,    77,     0,    57,    59,    60,    61,    73,    74,
      62,    72,    71,     0,     0,     0,     0,     0,    44,     0,
       0,     0,     0,    89,     0,    65,    66,    67,    68,    69,
       0,    70,     0,    46,     0,     0,    43,    50,    78,    40,
      58,    41,    82,     0,     0,    47,     0,     0,     0,     0,
       0,    79,    80,    83,     0,    48,    42
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,     2,     9,     5,    13,    31,    46,    32,    47,
      14,    15,    22,    23,    36,    37,    34,    35,    40,    54,
      43,    57,    51,    58,    59,    60,    61,    84,   105,    85,
      86,    62,    63,    93,    94,    78,   114,   115,   116,   117,
      98,    99,   118,   110,   136,   119,   120,   137,   138,   121,
      55,    75,    16,    17,   101,   102
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -86
static const yytype_int8 yypact[] =
{
     -86,    27,    10,   -86,    63,     8,   -86,   -86,   -86,   -86,
      29,    35,    36,   -86,   -86,    39,   -86,    53,   -86,   -86,
     -86,   -86,   -86,   -86,    46,   -86,   -86,   -86,    51,   -86,
     -86,    72,    74,   -86,    61,    73,    60,    77,   -86,   -86,
      71,   -86,    67,   -86,   -86,   -86,    68,    69,   -86,   -86,
     -86,    12,   -86,   -86,    70,    81,    67,   -86,   -86,   -86,
     -86,   -86,    29,    40,   -86,    32,   -86,   -86,   -86,    56,
     -86,    29,    87,    75,     9,    79,    16,   -86,    76,   -86,
     -86,   -86,    65,    78,     9,     4,   -86,   -86,   -86,   -86,
     -86,   -86,   -86,   -21,   -86,   -86,   -86,   -86,   -86,   -86,
     -86,   -86,   -86,    13,    80,    25,    64,    34,   -86,     9,
      88,    82,    16,    85,    84,   -86,   -86,   -86,   -86,   -86,
      92,   -86,    29,   -86,    78,    13,   -86,   -86,   -86,   -86,
     -86,   -86,   -86,    83,    86,   -86,    89,    93,    95,    13,
      13,   -86,   -86,   -86,    91,   -86,   -86
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -86,   -86,   -86,   -86,   -86,   -86,   -86,   -86,   -86,   -86,
     -86,   -86,   -86,   -86,   -86,   -86,   -86,   -86,   -86,   -86,
     -86,   -86,   -86,   -86,   -86,   -86,   -86,   -86,   -86,    18,
      -4,   -86,    49,   -86,     7,    -1,   -85,   -69,   -68,   -67,
     -70,   -86,   -66,   -86,   -86,   -86,   -86,   -86,   -86,   -18,
     -86,   -86,    -2,   -86,    -9,   -10
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -82
static const yytype_int16 yytable[] =
{
      25,    24,    82,   111,    87,    18,    19,    95,    96,    97,
     100,    10,   112,    20,    87,    81,    20,   113,    91,    81,
      20,    91,    81,    56,    50,    11,    12,     3,    21,   108,
       4,    21,    21,    20,    49,    21,   -54,   109,    68,    87,
     135,    65,    64,    95,    96,    97,   100,    92,    21,   123,
      92,   -54,    70,    64,   144,   145,    26,    27,   124,   126,
      28,    80,    79,    29,    89,    88,    71,   109,    72,    30,
      73,    74,    33,   106,    89,    88,     6,     7,     8,    76,
      38,    77,    39,    41,    44,    42,    45,    48,    49,    67,
      52,    53,    66,    81,   104,   128,   125,    21,    83,    89,
      88,    90,   107,   103,   143,   127,   122,   129,   -81,   131,
     139,    69,    80,    79,   134,   132,   146,   142,   140,   130,
       0,   133,     0,   141
};

static const yytype_int16 yycheck[] =
{
      10,    10,    72,    24,    74,     7,     8,    76,    76,    76,
      76,     3,    33,     4,    84,     6,     4,     4,     5,     6,
       4,     5,     6,    11,    42,    17,    18,     0,    19,    25,
      20,    19,    19,     4,    21,    19,     4,    33,    56,   109,
     125,    51,    51,   112,   112,   112,   112,    34,    19,    24,
      34,    19,    62,    62,   139,   140,    21,    21,    33,    25,
      21,    71,    71,    10,    74,    74,    26,    33,    28,    23,
      30,    31,    21,    83,    84,    84,    13,    14,    15,    23,
       8,    25,     8,    22,    24,    12,     9,    16,    21,     8,
      22,    22,    22,     6,    29,     7,    32,    19,    23,   109,
     109,    22,    84,    27,     9,   109,    26,    25,    23,    25,
      27,    62,   122,   122,   124,    23,    25,    24,    32,   112,
      -1,   122,    -1,    34
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    36,    37,     0,    20,    39,    13,    14,    15,    38,
       3,    17,    18,    40,    45,    46,    87,    88,    87,    87,
       4,    19,    47,    48,    89,    90,    21,    21,    21,    10,
      23,    41,    43,    21,    51,    52,    49,    50,     8,     8,
      53,    22,    12,    55,    24,     9,    42,    44,    16,    21,
      84,    57,    22,    22,    54,    85,    11,    56,    58,    59,
      60,    61,    66,    67,    89,    90,    22,     8,    84,    67,
      90,    26,    28,    30,    31,    86,    23,    25,    70,    89,
      90,     6,    75,    23,    62,    64,    65,    75,    89,    90,
      22,     5,    34,    68,    69,    72,    73,    74,    75,    76,
      77,    89,    90,    27,    29,    63,    90,    64,    25,    33,
      78,    24,    33,     4,    71,    72,    73,    74,    77,    80,
      81,    84,    26,    24,    33,    32,    25,    65,     7,    25,
      69,    25,    23,    70,    90,    71,    79,    82,    83,    27,
      32,    34,    24,     9,    71,    71,    25
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:

/* Line 1455 of yacc.c  */
#line 117 "grammar.y"
    {}
    break;

  case 5:

/* Line 1455 of yacc.c  */
#line 123 "grammar.y"
    {
	    if (list_add_int(cinclude, (yyvsp[(2) - (2)].integer)) == -1) YYERROR;
	    if (list_add_int(hinclude, (yyvsp[(2) - (2)].integer)) == -1) YYERROR;
	  }
    break;

  case 6:

/* Line 1455 of yacc.c  */
#line 128 "grammar.y"
    {
	    if (list_add_int(cinclude, (yyvsp[(2) - (2)].integer)) == -1) YYERROR;
	  }
    break;

  case 7:

/* Line 1455 of yacc.c  */
#line 132 "grammar.y"
    {
	    if (list_add_int(hinclude, (yyvsp[(2) - (2)].integer)) == -1) YYERROR;
	  }
    break;

  case 8:

/* Line 1455 of yacc.c  */
#line 139 "grammar.y"
    {}
    break;

  case 9:

/* Line 1455 of yacc.c  */
#line 141 "grammar.y"
    {}
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 143 "grammar.y"
    {}
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 148 "grammar.y"
    { lexer_mode = LEXER_C_CODE_NO_BRACKET; }
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 150 "grammar.y"
    { lexer_mode = LEXER_NORMAL; }
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 152 "grammar.y"
    {
	    string s = new_string(buffer);
	    if (s == -1) YYERROR;
	    if (list_add_int(ccode, s) == -1) YYERROR;
	  }
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 158 "grammar.y"
    { lexer_mode = LEXER_C_CODE_NO_BRACKET; }
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 160 "grammar.y"
    { lexer_mode = LEXER_NORMAL; }
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 162 "grammar.y"
    {
	    string s = new_string(buffer);
	    if (s == -1) YYERROR;
	    if (list_add_int(hcode, s) == -1) YYERROR;
	  }
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 171 "grammar.y"
    {}
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 176 "grammar.y"
    {
	    init_first_shot = 0;
	  }
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 180 "grammar.y"
    {
	    init_first_shot = 0;
	  }
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 187 "grammar.y"
    {
	    current_widget = new_widget((yyvsp[(1) - (1)].integer), -1);
	    if (current_widget == -1) YYERROR;
	  }
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 192 "grammar.y"
    {
	    fprintf(stderr, "%s:%d: keyword '%s' used as widget name, error\n",
	            get_current_file(), line+1, get_keyword((yyvsp[(1) - (1)].integer)));
	    YYERROR;
	  }
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 201 "grammar.y"
    {
	    current_widget = new_widget((yyvsp[(1) - (4)].integer), (yyvsp[(3) - (4)].integer));
	    if (current_widget == -1) YYERROR;
	  }
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 208 "grammar.y"
    { lexer_mode = LEXER_F_ARGS; }
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 210 "grammar.y"
    {
	    list l;
	    lexer_mode = LEXER_NORMAL;
	    l = parse_arguments(buffer);
	    if (l == -1) YYERROR;
	    (yyval.integer) = l;
	  }
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 220 "grammar.y"
    {}
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 225 "grammar.y"
    {}
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 227 "grammar.y"
    { lexer_mode = LEXER_INIT_VARS; }
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 229 "grammar.y"
    { lexer_mode = LEXER_NORMAL; }
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 231 "grammar.y"
    {
	    if (set_init_vars(current_widget, buffer) == -1) YYERROR;
	  }
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 237 "grammar.y"
    { init_first_shot = 1; }
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 239 "grammar.y"
    {
	    if (set_init_code(current_widget, (yyvsp[(2) - (2)].integer)) == -1) YYERROR;
	    init_first_shot = 1;
	  }
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 247 "grammar.y"
    {}
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 249 "grammar.y"
    {
	    if (set_post_init_code(current_widget, (yyvsp[(2) - (2)].integer)) == -1) YYERROR;
	  }
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 256 "grammar.y"
    {}
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 258 "grammar.y"
    {}
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 263 "grammar.y"
    {}
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 265 "grammar.y"
    {}
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 267 "grammar.y"
    {}
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 272 "grammar.y"
    {
	    /* names of elements must be unique */
	    if (widget_find_element(current_widget, (yyvsp[(2) - (3)].integer)) != -1) {
	      fprintf(stderr, "element %s declared twice\n",
		      get_identifier((yyvsp[(2) - (3)].integer)));
	      YYERROR;
	    }
	    if (widget_add_element(current_widget, (yyvsp[(1) - (3)].integer), (yyvsp[(2) - (3)].integer), -1) == -1)
	      YYERROR;
	  }
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 283 "grammar.y"
    {
	    /* names of elements must be unique */
	    if (widget_find_element(current_widget, (yyvsp[(2) - (6)].integer)) != -1) {
	      fprintf(stderr, "element %s declared twice\n",
		      get_identifier((yyvsp[(2) - (6)].integer)));
	      YYERROR;
	    }
	    if (widget_add_element(current_widget, (yyvsp[(1) - (6)].integer), (yyvsp[(2) - (6)].integer), (yyvsp[(4) - (6)].integer)) == -1)
	      YYERROR;
	  }
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 297 "grammar.y"
    {
	    widget_element e = widget_find_element(current_widget, (yyvsp[(1) - (6)].integer));
	    if (e == -1) {
	      fprintf(stderr, "element %s not declared\n",
		      get_identifier((yyvsp[(1) - (6)].integer)));
	      YYERROR;
	    }
	    if (set_property(current_widget, e, (yyvsp[(3) - (6)].integer), (yyvsp[(5) - (6)].property_value)) == -1) YYERROR;
	  }
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 308 "grammar.y"
    {
	    widget_element e = widget_find_element(current_widget, (yyvsp[(1) - (9)].integer));
	    if (e == -1) {
	      fprintf(stderr, "element %s not declared\n",
		      get_identifier((yyvsp[(1) - (9)].integer)));
	      YYERROR;
	    }
	    if ((yyvsp[(3) - (9)].integer) < 0 || (yyvsp[(3) - (9)].integer) >= list_size(widget_element_arguments(
                                              current_widget, e)) / 2) {
	      fprintf(stderr,
                      "number %d unallowed in [n] notation of element %s\n",
		      (yyvsp[(3) - (9)].integer), get_identifier((yyvsp[(1) - (9)].integer)));
	      fprintf(stderr, "max value allowed is %d\n",
	        list_size(widget_element_arguments(current_widget, e))/2-1);
	      YYERROR;
	    }
	    if (set_argument_property(current_widget, e, (yyvsp[(3) - (9)].integer), (yyvsp[(6) - (9)].integer), (yyvsp[(8) - (9)].property_value)) == -1)
	      YYERROR;
	  }
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 331 "grammar.y"
    {
	    int i;
	    int l;
	    widget_element e = widget_find_element(current_widget, (yyvsp[(1) - (5)].integer));
	    if (e == -1) {
	      fprintf(stderr, "element %s not declared\n",
		      get_identifier((yyvsp[(1) - (5)].integer)));
	      YYERROR;
	    }
	    /* menu may have "0" (represented as -2) as child */
	    l = list_size((yyvsp[(4) - (5)].integer));
	    if (widget_element_type(current_widget, e) != KEYWORD_MENU) {
	      for (i=0; i<l; i++)
	        if (list_get_int((yyvsp[(4) - (5)].integer), i) == -2) {
	          fprintf(stderr,
	              "packing 0 not allowed for element %s (type %s)\n",
	              get_identifier(widget_element_name(current_widget, e)),
	              get_keyword(widget_element_type(current_widget, e)));
	          YYERROR;
	        }
	    }
	    if (pack_new_row(current_widget, e, (yyvsp[(3) - (5)].integer)) == -1) YYERROR;
	    if (pack_append(current_widget, e, (yyvsp[(4) - (5)].integer)) == -1) YYERROR;
	    /* set dad */
	    for (i=0; i<l; i++) {
	      widget_element x = (widget_element)list_get_int((yyvsp[(4) - (5)].integer), i);
	      if (x == -2 || x == -3 || x == -4) continue;
	      widget_element_set_dad(current_widget, x, e);
	    }
	  }
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 362 "grammar.y"
    {
	    int i;
	    int l;
	    widget_element e = widget_find_element(current_widget, (yyvsp[(1) - (4)].integer));
	    if (e == -1) {
	      fprintf(stderr, "element %s not declared\n",
		      get_identifier((yyvsp[(1) - (4)].integer)));
	      YYERROR;
	    }
	    /* menu may have "0" (represented as -2) as child */
	    l = list_size((yyvsp[(3) - (4)].integer));
	    if (widget_element_type(current_widget, e) != KEYWORD_MENU) {
	      for (i=0; i<l; i++)
	        if (list_get_int((yyvsp[(3) - (4)].integer), i) == -2) {
	          fprintf(stderr,
	              "packing 0 not allowed for element %s (type %s)\n",
	              get_identifier(widget_element_name(current_widget, e)),
	              get_keyword(widget_element_type(current_widget, e)));
	          YYERROR;
	        }
	    }
	    if (pack_append(current_widget, e, (yyvsp[(3) - (4)].integer)) == -1) YYERROR;
	    /* set dad */
	    for (i=0; i<l; i++) {
	      widget_element x = (widget_element)list_get_int((yyvsp[(3) - (4)].integer), i);
	      if (x == -2 || x == -3 || x == -4) continue;
	      widget_element_set_dad(current_widget, x, e);
	    }
	  }
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 395 "grammar.y"
    {
	    (yyval.integer) = -1;
	  }
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 399 "grammar.y"
    {
	    (yyval.integer) = (yyvsp[(2) - (3)].integer);
	  }
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 406 "grammar.y"
    {
	    list l = new_list();
	    if (l == -1) YYERROR;
	    if (list_add_int(l, (yyvsp[(1) - (3)].integer)) == -1) YYERROR;
	    if (list_add_int(l, (yyvsp[(3) - (3)].property_value).type) == -1) YYERROR;
	    if ((yyvsp[(3) - (3)].property_value).type == PV_NUMBER) {
	      if (list_add_float(l, (yyvsp[(3) - (3)].property_value).v.d) == -1) YYERROR;
	    } else {
	      if (list_add_int(l, (yyvsp[(3) - (3)].property_value).v.value) == -1) YYERROR;
	    }
	    (yyval.integer) = l;
	  }
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 419 "grammar.y"
    {
	    if (list_add_int((yyvsp[(1) - (5)].integer), (yyvsp[(3) - (5)].integer)) == -1) YYERROR;
	    if (list_add_int((yyvsp[(1) - (5)].integer), (yyvsp[(5) - (5)].property_value).type) == -1) YYERROR;
	    if ((yyvsp[(5) - (5)].property_value).type == PV_NUMBER) {
	      if (list_add_float((yyvsp[(1) - (5)].integer), (yyvsp[(5) - (5)].property_value).v.d) == -1) YYERROR;
	    } else {
	      if (list_add_int((yyvsp[(1) - (5)].integer), (yyvsp[(5) - (5)].property_value).v.value) == -1) YYERROR;
	    }
	    (yyval.integer) = (yyvsp[(1) - (5)].integer);
	  }
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 433 "grammar.y"
    {
	    list l = new_list();
	    if (l == -1) YYERROR;
	    if (list_add_int(l, (yyvsp[(1) - (1)].integer)) == -1) YYERROR;
	    (yyval.integer) = l;
	  }
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 440 "grammar.y"
    {
	    if (list_add_int((yyvsp[(1) - (3)].integer), (yyvsp[(3) - (3)].integer)) == -1) YYERROR;
	    (yyval.integer) = (yyvsp[(1) - (3)].integer);
	  }
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 448 "grammar.y"
    {
	    widget_element e = widget_find_element(current_widget, (yyvsp[(1) - (1)].integer));
	    if (e == -1) {
	      fprintf(stderr, "packing unknown widget %s\n",
	        get_identifier((yyvsp[(1) - (1)].integer)));
	      YYERROR;
	    }
	    (yyval.integer) = e;
	  }
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 458 "grammar.y"
    {
	    /* special case of "separator", we return -3 */
	    if ((yyvsp[(1) - (1)].integer) == KEYWORD_SEPARATOR)
	      (yyval.integer) = -3;
	    /* special case of "resizer", we return -4 */
	    else if ((yyvsp[(1) - (1)].integer) == KEYWORD_RESIZER)
	      (yyval.integer) = -4;
	    else YYERROR;
	  }
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 468 "grammar.y"
    {
	    if ((yyvsp[(1) - (1)].integer) != 0) {
	      fprintf(stderr, "packing a number (%d) is not allowed\n", (yyvsp[(1) - (1)].integer));
	      YYERROR;
	    }
	    (yyval.integer) = -2;
	  }
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 479 "grammar.y"
    { (yyval.integer) = (yyvsp[(1) - (1)].integer); }
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 484 "grammar.y"
    { (yyval.integer) = (yyvsp[(1) - (1)].integer); }
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 486 "grammar.y"
    {
	    fprintf(stderr, "%s:%d: keyword '%s' used as widget name, error\n",
	            get_current_file(), line+1, get_keyword((yyvsp[(1) - (1)].integer)));
	    YYERROR;
	  }
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 495 "grammar.y"
    {
	    int l = new_list();
	    if (l == -1) YYERROR;
	    if (list_add_int(l, (yyvsp[(1) - (1)].widget_argument_value).type) == -1) YYERROR;
	    if ((yyvsp[(1) - (1)].widget_argument_value).type == WA_NUMBER) {
	      if (list_add_float(l, (yyvsp[(1) - (1)].widget_argument_value).v.d) == -1) YYERROR;
	    } else {
	      if (list_add_int(l, (yyvsp[(1) - (1)].widget_argument_value).v.value) == -1) YYERROR;
	    }
	    (yyval.integer) = l;
	  }
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 507 "grammar.y"
    {
	    if (list_add_int((yyvsp[(1) - (3)].integer), (yyvsp[(3) - (3)].widget_argument_value).type) == -1) YYERROR;
	    if ((yyvsp[(3) - (3)].widget_argument_value).type == WA_NUMBER) {
	      if (list_add_float((yyvsp[(1) - (3)].integer), (yyvsp[(3) - (3)].widget_argument_value).v.d) == -1) YYERROR;
	    } else {
	      if (list_add_int((yyvsp[(1) - (3)].integer), (yyvsp[(3) - (3)].widget_argument_value).v.value) == -1) YYERROR;
	    }
	    (yyval.integer) = (yyvsp[(1) - (3)].integer);
	  }
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 520 "grammar.y"
    {
	    (yyval.widget_argument_value).type = WA_KEYWORD;
	    (yyval.widget_argument_value).v.value = (yyvsp[(1) - (1)].integer);
	  }
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 525 "grammar.y"
    {
	    (yyval.widget_argument_value).type = WA_IDENTIFIER;
	    (yyval.widget_argument_value).v.value = (yyvsp[(1) - (1)].integer);
	  }
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 530 "grammar.y"
    {
	    (yyval.widget_argument_value).type = WA_NUMBER;
	    (yyval.widget_argument_value).v.d = (yyvsp[(1) - (1)].f);
	  }
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 535 "grammar.y"
    {
	    (yyval.widget_argument_value).type = WA_STRING;
	    (yyval.widget_argument_value).v.value = (yyvsp[(1) - (1)].integer);
	  }
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 543 "grammar.y"
    { (yyval.integer) = (yyvsp[(1) - (1)].integer); }
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 545 "grammar.y"
    {
	    fprintf(stderr, "%s:%d: property '%s' does not exist, error\n",
	            get_current_file(), line+1, get_identifier((yyvsp[(1) - (1)].integer)));
	    YYERROR;
	  }
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 554 "grammar.y"
    {
	    (yyval.property_value).type = PV_KEYWORD;
	    (yyval.property_value).v.value = (yyvsp[(1) - (1)].integer);
	  }
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 559 "grammar.y"
    {
	    (yyval.property_value).type = PV_IDENTIFIER;
	    (yyval.property_value).v.value = (yyvsp[(1) - (1)].integer);
	  }
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 564 "grammar.y"
    {
	    (yyval.property_value).type = PV_NUMBER;
	    (yyval.property_value).v.d = (yyvsp[(1) - (1)].f);
	  }
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 569 "grammar.y"
    {
	    (yyval.property_value).type = PV_STRING;
	    (yyval.property_value).v.value = (yyvsp[(1) - (1)].integer);
	  }
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 574 "grammar.y"
    {
	    //if (function_call_to_c_code() == -1) YYERROR;
	    (yyval.property_value).type = PV_C_CODE;
	    (yyval.property_value).v.value = (yyvsp[(1) - (1)].integer);
	  }
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 580 "grammar.y"
    {
	    (yyval.property_value).type = PV_C_CODE;
	    (yyval.property_value).v.value = (yyvsp[(1) - (1)].integer);
	  }
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 588 "grammar.y"
    { (yyval.integer) = (yyvsp[(1) - (1)].integer); }
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 593 "grammar.y"
    { (yyval.integer) = (yyvsp[(1) - (1)].integer); }
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 598 "grammar.y"
    {
	    (yyval.f) = (yyvsp[(1) - (1)].integer);
	  }
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 602 "grammar.y"
    {
	    (yyval.f) = (yyvsp[(1) - (1)].f);
	  }
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 609 "grammar.y"
    {
	    int x;
	    if (sscanf(buffer, "%d", &x) != 1) {
	      fprintf(stderr, "bad number\n");
	      YYERROR;
	    }
	    (yyval.integer) = x;
	  }
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 621 "grammar.y"
    {
	    float x;
	    if (sscanf(buffer, "%f", &x) != 1) {
	      fprintf(stderr, "bad number\n");
	      YYERROR;
	    }
	    (yyval.f) = x;
	  }
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 633 "grammar.y"
    { lexer_mode = LEXER_C_STRING; }
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 635 "grammar.y"
    {lexer_mode = LEXER_NORMAL; }
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 637 "grammar.y"
    {
	    (yyval.integer) = new_string(buffer);
	    if ((yyval.integer) == -1) YYERROR;
	  }
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 645 "grammar.y"
    {
	    char *s;
	    buffer_size = 0;
	    if (put('{') == -1) YYERROR;
	    s = get_string((yyvsp[(1) - (4)].integer));
	    while (*s) { if (put(*s) == -1) YYERROR; s++; }
	    if (put('(') == -1) YYERROR;
	    s = get_string((yyvsp[(3) - (4)].integer));
	    while (*s) { if (put(*s) == -1) YYERROR; s++; }
	    if (put(')') == -1) YYERROR;
	    if (put(';') == -1) YYERROR;
	    if (put('}') == -1) YYERROR;
	    if (put(0) == -1) YYERROR;
	    (yyval.integer) = new_string(buffer);
	    if ((yyval.integer) == -1) YYERROR;
	  }
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 665 "grammar.y"
    {
	    (yyval.integer) = new_string(buffer);
	    if ((yyval.integer) == -1) YYERROR;
	  }
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 672 "grammar.y"
    { lexer_mode = LEXER_F_ARGS; }
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 674 "grammar.y"
    {
	    lexer_mode = LEXER_NORMAL;
	    (yyval.integer) = new_string(buffer);
	    if ((yyval.integer) == -1) YYERROR;
	  }
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 683 "grammar.y"
    { lexer_mode = LEXER_C_CODE; }
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 685 "grammar.y"
    { lexer_mode = LEXER_NORMAL; }
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 687 "grammar.y"
    {
	    (yyval.integer) = new_string(buffer);
	    if ((yyval.integer) == -1) YYERROR;
	  }
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 694 "grammar.y"
    { lexer_mode = LEXER_INCLUDE_STUFF; }
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 696 "grammar.y"
    {
	    lexer_mode = LEXER_NORMAL;
	    (yyval.integer) = new_string(buffer);
	    if ((yyval.integer) == -1) YYERROR;
	  }
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 704 "grammar.y"
    {
	    (yyval.integer) = new_identifier(buffer);
	    if ((yyval.integer) == -1) YYERROR;
	  }
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 711 "grammar.y"
    {
	    (yyval.integer) = buffer_keyword;
	  }
    break;



/* Line 1455 of yacc.c  */
#line 2483 "y.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 714 "grammar.y"


/* C code */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

/* return 0 if ok, -1 if error */
int put(int c)
{
  if (buffer_size == buffer_maxsize) {
    char *nb;
    if (!buffer_size)
      nb = malloc(256);
    else
      nb = realloc(buffer, buffer_maxsize + 256);
    if (!nb) {
      fprintf(stderr, "out of memory\n");
      return -1;
    }
    buffer = nb;
    buffer_maxsize += 256;
  }
  buffer[buffer_size] = c;
  buffer_size++;
  return 0;
}

int get_byte(void)
{
  int c = get();
  if (c == EOF) return -1;
  if (c == '\n') line++;
  return c;
}

void unget_byte(int c)
{
  if (c == '\n') line--;
  unget(c);
}

/* -1 error, 0 no comment, 1 comment removed */
int check_comments(int c, int put_it)
{
  if (c != '/') return 0;
  c = get_byte();

  if (c == '*') {
    if (put_it) if (put('/') == -1 || put('*') == -1) return -1;
    while (1) {
      do {
        c = get_byte();
        if (c == -1) { fprintf(stderr, "bad C comment\n"); return -1; }
        if (put_it) if (put(c) == -1) return -1;
      } while (c != '*');
      c = get_byte();
      if (c == '/') {
        if (put_it) if (put(c) == -1) return -1;
        return 1;
      }
      unget_byte(c);
    }
  }

  if (c == '/') {
    if (put_it) if (put('/') == -1 || put('/') == -1) return -1;
    while (1) {
      c = get_byte();
      if (put_it && c != -1) if (put(c) == -1) return -1;
      if (c == '\n') return 1;
      if (c == -1) { fprintf(stderr, "bad C comment\n"); return -1; }
    }
  }

  unget_byte(c);
  return 0;
}

/* return 0 if ok, -1 if error */
int get_full_string(int sep)
{
  int c = get_byte();
  int last_escape = 0;

  if (c != sep) return -1;

  do {
    if (put(c) == -1) return -1;
    if (last_escape) last_escape = 0; else last_escape = (c == '\\');
    c = get_byte();
    if (c == -1) {
      fprintf(stderr, "unterminated string sequence\n");
      return -1;
    }
  } while (c != sep || last_escape);

  if (put(sep) == -1) return -1;

  return 0;
}

static int _get_c_code(int put_it)
{
  int depth = 0;
  if (put_it) if (put('{') == -1) return -1;
  while (1) {
    int c = get_byte();
    int comment;

    if (c == -1) {
      fprintf(stderr,
              put_it ? "bad C code\n" : "bad init variables' block\n");
      return -1;
    }

    comment = check_comments(c, 1);
    if (comment == -1) return -1;
    if (comment == 1) continue;

    if (c == '}' && depth == 0) {
      unget_byte(c);
      if (put_it) if (put('}') == -1) return -1;
      if (put(0) == -1) return -1;
      if (put_it) return C_CODE;
      return INIT_VARS;
    }

    if (put(c) == -1) return -1;

    if (c == '{') depth++;
    if (c == '}') depth--;

    if (c == '"' || c == '\'') {
      buffer_size--;
      unget_byte(c);
      if (get_full_string(c) == -1)
        return -1;
    }
  }
}

int get_c_code(void)
{
  return _get_c_code(1);
}

int get_init_vars(void)
{
  return _get_c_code(0);
}

int get_c_code_no_bracket(void)
{
  /* let's use _get_c_code(0), but change its return value */
  int r = _get_c_code(0);
  if (r != INIT_VARS) return r;
  return C_CODE;
}

int get_c_string(void)
{
  int c = get_byte();
  int last_escape = 0;

  while (c != '"' || last_escape) {
    if (put(c) == -1) return -1;
    if (last_escape) last_escape = 0; else last_escape = (c == '\\');
    c = get_byte();
    if (c == -1) {
      fprintf(stderr, "bad C string\n");
      return -1;
    }
  }

  if (put(0) == -1) return -1;

  unget_byte('"');

  return C_STRING;
}

int get_include_stuff(void)
{
  while (1) {
    int c = get_byte();
    if (c == -1 || c == '\n') {
      if (put(0) == -1) return -1;
      break;
    }
    if (put(c) == -1) return -1;
  }

  return INCLUDE_STUFF;
}

int get_f_args(void)
{
  int c = get_byte();
  int depth = 0;

  while (c != ')' || depth) {
    int comment = check_comments(c, 0);
    if (comment == -1) return -1;

    if (!comment) if (put(c) == -1) return -1;
    if (c == '(') depth++;
    if (c == ')') depth--;
    if (c == '"' || c == '\'') {
      buffer_size--;
      unget_byte(c);
      if (get_full_string(c) == -1)
        return -1;
    }
    c = get_byte();
    if (c == -1) {
      fprintf(stderr, "bad function arguments\n");
      return -1;
    }
  }

  if (put(0) == -1) return -1;

  unget_byte(')');

  return F_ARGS;
}

int yylex(void)
{
  int c;
  int comment;
  keyword k;

lex_more:
  buffer_size = 0;

  if (lexer_mode == LEXER_C_CODE)
    return get_c_code();

  if (lexer_mode == LEXER_INIT_VARS)
    return get_init_vars();

  if (lexer_mode == LEXER_C_CODE_NO_BRACKET)
    return get_c_code_no_bracket();

  if (lexer_mode == LEXER_C_STRING)
    return get_c_string();

  if (lexer_mode == LEXER_F_ARGS)
    return get_f_args();

  if (lexer_mode == LEXER_INCLUDE_STUFF)
    return get_include_stuff();

  /* let's remove spaces */
  while (1) {
    c = get_byte();
    if (c == -1) return -1;
    if (!isspace(c))
      break;
  }

  /* keyword or identifier */
  if ((c >= 'a' && c <= 'z') ||
      (c >= 'A' && c <= 'Z') ||
      c == '_') {
    while (1) {
      if (put(c) == -1) return -1;
      c = get_byte();
      if ((c >= 'a' && c <= 'z') ||
          (c >= 'A' && c <= 'Z') ||
          (c >= '0' && c <= '9') ||
          c == '_')
        continue;
      unget_byte(c);
      if (put(0) == -1) return -1;
      switch ((k=lookup(buffer, buffer_size-1))) {
        case NULL_KEYWORD:
          return IDENTIFIER;
        case KEYWORD_WIDGET:
          return WIDGET;
        case KEYWORD_INCLUDE:
          return INCLUDE;
        case KEYWORD_CINCLUDE:
          return CINCLUDE;
        case KEYWORD_HINCLUDE:
          return HINCLUDE;
        case KEYWORD_INIT:
          if (init_first_shot == 0)
            return INIT;
          else
            return POST_INIT;
        case KEYWORD_CCODE:
          return CCODE;
        case KEYWORD_HCODE:
          return HCODE;
        default:
          buffer_keyword = k;
          return KEYWORD;
      }
    }
  }

  /* number (integer or float) */
  if (c >= '0' && c <= '9') {
    int dot_done = 0;
    while (1) {
      if (put(c) == -1) return -1;
      c = get_byte();
      if (c >= '0' && c <= '9')
        continue;
      if (c == '.' && !dot_done) {
        dot_done = 1;
        continue;
      }
      unget_byte(c);
      if (put(0) == -1) return -1;
      return dot_done ? FLOAT : INTEGER;
    }
  }

  /* comments */
  comment = check_comments(c, 0);
  if (comment == -1) return -1;
  if (comment == 1) goto lex_more;

  return c;
}

void yyerror(char *s)
{
  fprintf(stderr, "%s:%d:%s\n", get_current_file(), line+1, s);
}

void end_parse(void)
{
  if (!buffer_maxsize) return;
  free(buffer);
  buffer_size = buffer_maxsize = 0;
  buffer = 0;
}

